using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Infragistics.WebUI.UltraWebGrid;
namespace MultiSelectWebCombo
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //create datasource
                DataTable tbl = new DataTable();
                tbl.Columns.Add("Id", typeof(int));
                tbl.Columns.Add("Checked", typeof(bool));
                tbl.Columns.Add("Text");
                for (int i = 0; i < 15; i++)
                {
                    tbl.Rows.Add(new object[] { i, false, "Test " + i });
                }
                WebCombo1.DataTextField = "Text";
                WebCombo1.DataValueField = "Id";
                WebCombo1.DataSource = tbl;
                WebCombo1.DataBind();

                //just some adjusting of the height
                if (WebCombo1.Rows.Count > 5)
                {
                    WebCombo1.DropDownLayout.DropdownHeight = Unit.Pixel(110);
                }

                //get a reference to the grid in the combo
                UltraWebGrid grid = (UltraWebGrid)WebCombo1.Controls[0];

                if (grid != null)
                {
                    //set some properties of the grid to act and look like a combo
                    grid.Columns.FromKey("Checked").AllowUpdate = AllowUpdate.Yes;
                    grid.DisplayLayout.ClientSideEvents.CellClickHandler = "GridCellClickHandler";
                    grid.DisplayLayout.ClientSideEvents.AfterCellUpdateHandler = "GridAfterCellUpdateHandler";
                    grid.Columns.FromKey("Checked").CellStyle.BorderWidth = Unit.Pixel(0);
                    grid.Columns.FromKey("Text").CellStyle.BorderWidth = Unit.Pixel(0);
                    grid.DisplayLayout.ActivationObject.BorderStyle = BorderStyle.None;
                    grid.Columns.FromKey("Checked").Width = Unit.Pixel(15);
                    grid.Columns.FromKey("Text").Width = Unit.Pixel(160);
                    grid.Columns.FromKey("Id").Hidden = true;
                }

                //set clientside events Combo box Properties for look
                WebCombo1.ClientSideEvents.AfterCloseUp = "WebCombo1_AfterCloseUp";
                WebCombo1.ClientSideEvents.BeforeCloseUp = "WebCombo1_BeforeCloseUp";
                WebCombo1.ClientSideEvents.BeforeSelectChange = "WebCombo1_BeforeSelectChange";
                WebCombo1.DropDownLayout.RowSelectors = RowSelectors.No;
                WebCombo1.DropDownLayout.GridLines = UltraGridLines.None;
                WebCombo1.DropDownLayout.ColHeadersVisible = ShowMarginInfo.No;
                WebCombo1.DropDownLayout.DropdownWidth = Unit.Pixel(200);
                WebCombo1.DropDownLayout.FrameStyle.BackColor = System.Drawing.Color.Transparent;
                WebCombo1.Width = Unit.Pixel(200);
                //if set to false then selected values won't show in combo until you click another spot on the form
                WebCombo1.Editable = true;
            }
        }

        protected void btnShowServerValues_Click(object sender, EventArgs e)
        {
            lst.Items.Clear();
            UltraWebGrid grid = (UltraWebGrid)WebCombo1.Controls[0];
            foreach (UltraGridRow row in grid.Rows)
            {
                bool isChecked = (bool)row.Cells.FromKey("Checked").Value;
                if (isChecked)
                {
                    lst.Items.Add(row.Cells.FromKey("Id").Value + " - " + row.Cells.FromKey("Text").Value);
                }
            }
        }
    }
}
